//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <math.h>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
#include "Custom.h"
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
	TButton *btStart;
	TPanel *pnMinesLeft;
	TMainMenu *menuMain;
	TMenuItem *mmiGame;
	TMenuItem *mmiEasy;
	TMenuItem *mmiMedium;
	TMenuItem *mmiHard;
	TMenuItem *mmiCustom;
	TMenuItem *N1;
	TMenuItem *mmiExit;
	TMenuItem *mmiHelp;
	TMenuItem *mmiAbout;
	TMenuItem *N2;
 void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall btStartClick(TObject *Sender);
	void __fastcall mmiEasyClick(TObject *Sender);
	void __fastcall mmiMediumClick(TObject *Sender);
	void __fastcall mmiHardClick(TObject *Sender);
	void __fastcall mmiCustomClick(TObject *Sender);
	void __fastcall mmiExitClick(TObject *Sender);
	void __fastcall mmiAboutClick(TObject *Sender);
	void __fastcall N2Click(TObject *Sender);
private:	// User declarations
 float s32; /*   3  */
 float xoffs; /*    X */
 float yoffs; /*    Y */
 int a; /*    */
 int n; /*      */
 int mines; /*     */
 int emptyfields; /*      */
 int minesleft; /*    */
 char firstclick; /*   ? */
 char theend; /*   */
 char *field; /*    ,  */
 DWORD col[9]; /*     -  , 7 - 
                    4 ,    */
 char lbp; /*      */
 char rbp; /*      */

public:		// User declarations
 __fastcall TfmMain(TComponent* Owner);
 void DrawCell(int X, int Y);
 void PaintFields(void);
 float GetX(int i, int j);
 float GetY(int i, int j);
 int GetOffs(int i, int j);
 void InitFieldArray(void);
 void ClickField(int i, int j);
 char IsMine(int i, int j);
 void CountMineNum(void);
 void MarkFields(void);
 void GetNeibs(char &ul, char &ur, char &r, char &br, char &bl, char &l, int i, int j);
 void ShowEmptyArea(int i, int j);
 char IsHidden(int i, int j);
 char IsEmpty(int i, int j);
 void LeftButtonClick(int i, int j);
 void RightButtonClick(int i, int j);
 void BeginGame(void);
 void InitConfig(void);
};

//---------------------------------------------------------------------------
extern TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
